library(Iso)
library(fdrtool)
dist.calc <- function(data,gridsize=200){
	q <- 0.6792
	n <- length(data) ## Length of the data set
	data <- sort(data) ## Sorts the data set
	data.1 <- unique(data) ## Finds the unique data points
	Fn <- ecdf(data) ## Computes the empirical DF of the data 
	Fn.1 <- Fn(data.1) ## Empirical DF of the data at the data points 
	## Calculate the known F_b at the data points
	## Note: for Uniform(0,1) F_b(x) = x
	## Usually would need to CHANGE this
	Fb <- pnorm(data.1)   #################################################### here added pnorm()
	## Compute the weights (= frequency/n) of the unique data values, i.e., dF_n
	Freq <- diff(c(0,Fn.1))
	distance <- rep(0,floor(gridsize*.12))
	distance[0]<- sqrt(t((Fn.1-Fb)^2)%*%Freq)
	
	grid.pts <- {1:floor(gridsize)} /gridsize
	for(ii in 1:length(grid.pts)){
		# print(i)
		aa <- grid.pts[ii]
		F.hat <- (Fn.1-(1-aa)*Fb)/aa ## Computes the naive estimator of F_s
		F.is=pava(F.hat,Freq,decreasing=FALSE) ## Computes the Isotonic Estimator of F_s
		F.is[which(F.is<=0)]=0
		F.is[which(F.is>=1)]=1
		distance[ii] <- aa*sqrt(t((F.hat-F.is)^2)%*%Freq);
	}
	# Lower.Cfd.Bound <- sum(distance>q/sqrt(n))/gridsize
	ret <- list( distance = distance,
				gridsize = gridsize,
				grid.pts = grid.pts,
				F.n = Fn.1,
			 	F.n.x = data.1,
				Freq = Freq,
				F.b = Fb,
				n = n)
	class(ret) <- "dist.fun"
	ret$call <- match.call()

	return(ret)
}
print.dist.fun <- function(x,...){
	cat("Call:\n")
	print(x$call)
	t.mat<- cbind(x$grid.pts , x$distance)
	colnames(t.mat) = c("gamma", "distance")
	print(t(t.mat))
}
plot.dist.fun <- function(x,...){
	plot(x$grid.pts, x$distance, ylab= "distance", xlab= "gamma" , type ="l")
}
